import { Component, Input, OnInit } from '@angular/core';
import { IItem} from '../models/item'

interface IColor {
  red: number,
  green: number,
  blue: number,
  alpha: number,
}

interface IGradientstop {
  relativestop: number,
  color: IColor
}

@Component({
  selector: 'fm-gradient',
  templateUrl: './gradient.component.html',
  styleUrls: ['./gradient.component.scss']
})
export class GradientComponent implements OnInit {

  @Input() item:IItem;
  public gradientStyle:any = {};

  constructor() { }

  getGradientStyle(item:IItem):any {
    if(item.data && item.data.gradient) {
      let gradient = item.data.gradient as IGradientstop[];
      let gd = '{ "background": "linear-gradient(to right,';
      for(var i=0;i<gradient.length;i++) {
        let gs = gradient[i];
        if(i>0) gd+=",";
        gd += `rgba(${gs.color.red},${gs.color.green},${gs.color.blue},${gs.color.alpha/255})`;          
        gd +=` ${gs.relativestop*100}%`
      }
      gradient.forEach((gs) => {
      });
      gd+=')"}';
      
      return JSON.parse(gd);
    }
  }

  ngOnInit(): void {
    if(this.item.itemType == "vnd.farmmaps.itemtype.gradient") {
       if(this.item) {
         this.gradientStyle = this.getGradientStyle(this.item);
       }
    }
  }
}
